#include <stdio.h>
/*Declaracin de prototipos:*/
/*Funcin que mueve los discos de la varilla 1 a
 la 3 usando como auxiliar la 2*/
void hanoi(int n, int a, int b, int c); 

int main(int argc, char *argv[])
{
    /* a es la varilla 1
       b es la varilla 2, la que usaremos como auxiliar
       c es la varilla 3, a la que queremos trasladar los discos
       n hace referencia al nmero de discos
    */
	int n;
	int a,b,c;
    a=1;
    b=2;
    c=3;
	printf("Introduzca el nmero de discos en la primera varilla:");
	scanf("%d",&n);
    hanoi(n,a,b,c);
	return 0;
}


void hanoi(int n, int a, int b, int c)
{  
    /* La funcin recibe n, el n de discos, y las 3 varillas en las que se intercambian
    los discos de la 1 a la 3 usando la 2 como auxiliar 
    
    * El disco pequeo se debe mover siempre cclicamente en el mismo sentido: hacia la derecha 
    (de A a B, de B a C y de C a A) o hacia la izquierda (de A a C, de C a B y de B a A), segn 
    el nmero de discos sea par o impar respectivamente.
    * El disco pequeo se debe colocar siempre, bien sobre un disco de nmero par, bien como nico 
    disco en el poste de destino (C) si el nmero de discos es impar o en el otro (B) si es par.
    
    Teniendo en cuenta la segunda regla, el algoritmo podra ser el siguiente.

    1. Si es posible, lleva el disco 1 sobre un disco de nmero par. Si no es posible, llvalo al poste B si 
    n es par o a C si n es impar.
    2. Si todos los discos estn en C, fin. Si no, mueve un disco que no sea el 1 y vuelve al paso 1.
    
    */
    if (n > 0) {
    static int i=1;
    hanoi(n-1, a, c, b);
    printf("(Movimiento %d)Mover disco %d de la varilla %d a la %d\n",i, n, a, c);
    i++;
    hanoi(n-1, b, a, c);
	}
   
}


